<template>
    <div class="card" v-for="(news, index) in allNews" :key="index">
        <img class="card-image" :src="news.urlToImage" alt="Avatar">
        <div class="card-body">
            <h2 class="card-title">{{ strLimit(news.title, 50) }}</h2>
            <p class="card-author">{{ news.author }}</p>
            <p class="card-content">
                {{strLimit(news.content, 80)}}
            </p>
            <div class="card-action">
                <button class="btn" @click="viewNews(news)">View</button>
                <button class="btn">Bookmark</button>
            </div>
        </div>
        <div class="card-footer">
            <label>Published: {{ mutatePublishedDate(news.publishedAt) }}</label>
        </div>
    </div>
</template>

<script>
import moment from 'moment'
export default {
    emits:['viewNews'],
    props: {
        allNews: Array,
    },
    methods: {
        viewNews(e) {
            this.$emit('viewNews', e)
        },
        strLimit(value, size = 20) {
            if (!value) return '';   
            value = value.toString();

            if (value.length <= size) {
            return value;
            }

            return value.substr(0, size) + ' ...';
        },
        mutatePublishedDate(date){
            return moment(date).format("YYYY[/]M[/]D"); 
        }
    },
}
</script>